
BICfct<-function(A, B, n,p){
  ##################### 
  # INPUTS
  ##################### 
  # A : list of sample covariance matrix estimates
  # B : list of precision matrix estimates
  # n : vector of sample sizes in each group
  # p : number of variables
  #################### 
  # OUTPUT
  ##################### 
  # BIC criterion
  
  B<-lapply(B,as.matrix)
  loglik<- sum(mapply(function(A,B,n) n*(sum(diag(A%*%as.matrix(B)))) - n*log(det(as.matrix(B))), A=A, B=B, n=n))
  diagdiff<- sum(apply(array(unlist(lapply(B,diag)),dim=c(p,length(B))),1,function(t) (sum(unique(t)!=0))))
  diff<- sum(apply(array(unlist(B), dim = c(p, p, length(B))),c(1,2),function(t) (sum(unique(t)!=0))))
  df<-(diff-diagdiff)*0.5+diagdiff
  
  return(loglik + log(sum(n))*df)
}
