
kendall.transformed<-function(x){
  ########
  # INPUT
  ########
  # x : Data matrix of dimension N X p (N: number of observations, p: number of variables)
  ########
  # OUTPUT
  ########
  # Cellwise robust covariance matrix estimate based on pairwise Kendall correlation and the Qn scale estimate
  
  x.q=apply(x,2,Qn)
  cor.kendall<- cor.fk(x)
  sigma.kendall=diag(x.q)%*% cor.kendall%*%diag(x.q)
  return(easy.psd(sigma.kendall))	
}

easy.psd<-function(sigma)
{
  # returns the nearest semipositive definite matrix from sigma
    eig<-eigen(sigma, symmetric=T)
    d<-pmax(eig$values,0)
    sigma.psd<-eig$vectors%*%diag(d)%*%t(eig$vectors)
    return(sigma.psd)
}
