
predict.DA<- function (means, theta, priors, x, type) 
{
  ######################## 
  # INPUTS
  ########################
  # means: list of K mean estimates
  # theta : either a list of K precision matrices (when QDA) or one single common precision matrix estimate
  # priors : vector of prior probabilities of each group
  # x : new data for which the groups are to predict
  # type: either QDA or LDA
  ######################## 
  # OUTPUTs
  ########################
  # class: class prediction for each observation
  # posterior: discriminant values
  
  if(type=="QDA"){
    probs <- apply(x, 1,function(x) mapply( function(mean, omega,priors) {0.5* log(det(as.matrix(omega)))  -
        0.5* as.double(unlist(x-mean)%*% as.matrix(omega) %*% unlist(x-mean)) +
        log(priors)}, omega=theta, mean=means,priors=priors))
  }
  if(type=="LDA"){
    probs <- apply(x, 1,function(x) mapply( function(mean,priors) {0.5* log(det(as.matrix(theta)))  -
        0.5* as.double(unlist(x-mean)%*% as.matrix(theta) %*% unlist(x-mean)) +
        log(priors)},mean=means,priors=priors))
  }
  cl = apply(probs, 2,function(p)which.max(p))
  score= unlist(lapply(1:nrow(x), function(i) probs[cl[i],i]))
  return(list(cl=cl,score=score))
}



